/**********************************************************************
 *<
	FILE: maxPluginTest.cpp

	DESCRIPTION:	Appwizard generated plugin

	CREATED BY: 

	HISTORY: 

 *>	Copyright (c) 2003, All Rights Reserved.
 **********************************************************************/

#include "maxPluginTest.h"

#define maxPluginTest_CLASS_ID	Class_ID(0x9adaf698, 0xcbe0889e)

class maxPluginTest : public SceneExport {
	public:
		
		static HWND hParams;
		
		int				ExtCount();					// Number of extensions supported
		const TCHAR *	Ext(int n);					// Extension #n (i.e. "3DS")
		const TCHAR *	LongDesc();					// Long ASCII description (i.e. "Autodesk 3D Studio File")
		const TCHAR *	ShortDesc();				// Short ASCII description (i.e. "3D Studio")
		const TCHAR *	AuthorName();				// ASCII Author name
		const TCHAR *	CopyrightMessage();			// ASCII Copyright message
		const TCHAR *	OtherMessage1();			// Other message #1
		const TCHAR *	OtherMessage2();			// Other message #2
		unsigned int	Version();					// Version number * 100 (i.e. v3.01 = 301)
		void			ShowAbout(HWND hWnd);		// Show DLL's "About..." box

		BOOL SupportsOptions(int ext, DWORD options);
		int				DoExport(const TCHAR *name,ExpInterface *ei,Interface *i, BOOL suppressPrompts=FALSE, DWORD options=0);

		//Constructor/Destructor
		maxPluginTest();
		~maxPluginTest();		

};



class maxPluginTestClassDesc : public ClassDesc2 {
	public:
	int 			IsPublic() { return TRUE; }
	void *			Create(BOOL loading = FALSE) { return new maxPluginTest(); }
	const TCHAR *	ClassName() { return GetString(IDS_CLASS_NAME); }
	SClass_ID		SuperClassID() { return SCENE_EXPORT_CLASS_ID; }
	Class_ID		ClassID() { return maxPluginTest_CLASS_ID; }
	const TCHAR* 	Category() { return GetString(IDS_CATEGORY); }

	const TCHAR*	InternalName() { return _T("maxPluginTest"); }	// returns fixed parsable name (scripter-visible name)
	HINSTANCE		HInstance() { return hInstance; }					// returns owning module handle
	

};

static maxPluginTestClassDesc maxPluginTestDesc;
ClassDesc2* GetmaxPluginTestDesc() { return &maxPluginTestDesc; }





INT_PTR CALLBACK maxPluginTestOptionsDlgProc(HWND hWnd,UINT message,WPARAM wParam,LPARAM lParam) {
	static maxPluginTest *imp = NULL;

	switch(message) {
		case WM_INITDIALOG:
			imp = (maxPluginTest *)lParam;
			CenterWindow(hWnd,GetParent(hWnd));
			return TRUE;

		case WM_CLOSE:
			EndDialog(hWnd, 0);
			return 1;
	}
	return 0;
}


//--- maxPluginTest -------------------------------------------------------
maxPluginTest::maxPluginTest()
{

}

maxPluginTest::~maxPluginTest() 
{

}

int maxPluginTest::ExtCount()
{
	//TODO: Returns the number of file name extensions supported by the plug-in.
	return 1;
}

const TCHAR *maxPluginTest::Ext(int n)
{		
	//TODO: Return the 'i-th' file name extension (i.e. "3DS").
	return _T("txt");
}

const TCHAR *maxPluginTest::LongDesc()
{
	//TODO: Return long ASCII description (i.e. "Targa 2.0 Image File")
	return _T("MaxPlugin Test");
}
	
const TCHAR *maxPluginTest::ShortDesc() 
{			
	//TODO: Return short ASCII description (i.e. "Targa")
	return _T("My ASCII");
}

const TCHAR *maxPluginTest::AuthorName()
{			
	//TODO: Return ASCII Author name
	return _T("dolphin");
}

const TCHAR *maxPluginTest::CopyrightMessage() 
{	
	// Return ASCII Copyright message
	return _T("Free");
}

const TCHAR *maxPluginTest::OtherMessage1() 
{		
	//TODO: Return Other message #1 if any
	return _T("");
}

const TCHAR *maxPluginTest::OtherMessage2() 
{		
	//TODO: Return other message #2 in any
	return _T("");
}

unsigned int maxPluginTest::Version()
{				
	//TODO: Return Version number * 100 (i.e. v3.01 = 301)
	return 100;
}

void maxPluginTest::ShowAbout(HWND hWnd)
{			
	// Optional
}

BOOL maxPluginTest::SupportsOptions(int ext, DWORD options)
{
	// TODO Decide which options to support.  Simply return
	// true for each option supported by each Extension 
	// the exporter supports.

	return TRUE;
}


int	maxPluginTest::DoExport(const TCHAR *name,ExpInterface *ei,Interface *i, BOOL suppressPrompts, DWORD options)
{
	//TODO: Implement the actual file Export here and 
	//		return TRUE If the file is exported properly

	if(!suppressPrompts)
		DialogBoxParam(hInstance, 
				MAKEINTRESOURCE(IDD_PANEL), 
				GetActiveWindow(), 
				maxPluginTestOptionsDlgProc, (LPARAM)this);
	return FALSE;
}


